<template lang="pug">
  .container
    article.message.is-danger.has-image-centered(v-if="errorMessage != null")
      .message-header
        p {{errorMessage}}
        button.delete(aria-label="delete",@click="onCloseErrorMessage")
    .tile.is-ancestor
      .tile.is-4
      .tile.is-4.tile.is-child
        form(@submit.prevent="onSignup")
          .field
            label.label User Name
            input.input(name="userName", id="userName", v-model="userName", type="text", required)
          .field
            label.label Email
            input.input(name="email", id="email", v-model="email", type="email", required)
          .field
            label.label Password        
            input.input(name="password", id="password", v-model="password", type="password", required)
          .field
            label.label Confirm Password   
            input.input(name="confirmPassword", id="confirmPassword", v-model="confirmPassword", type="password")
            p.help.is-danger {{comparePasswords}}
          .field.is-grouped
            .control
              button.button.is-primary(type="submit", :disabled="loading", :class="{'is-loading': loading}") Sign up
            .control
              router-link.button.is-ligh(:to="{ path: '/signin' }", :class="{'is-loading': loading}") Sign In
          br
          .field.is-grouped
            .control        
              a.button.is-dark(:disabled="loading", :class="{'is-loading': loading}",@click.prevent="onSigninGoogle")
                span.icon.is-small
                  font-awesome-icon(:icon="['fab', 'google']")
                span Login with Google          
            .control
              a.button.is-dark(:disabled="loading",:class="{'is-loading': loading}",@click.prevent="onSigninFacebook") 
                span.icon.is-small
                  font-awesome-icon(:icon="['fab', 'facebook']")
                span Login with Facebook          
            .control
              a.button.is-dark(:disabled="loading",:class="{'is-loading': loading}",@click.prevent="onSigninTwitter")
                span.icon.is-small
                  font-awesome-icon(:icon="['fab', 'twitter']")
                span Login with Twitter 
      .tile.is-4
</template>

<style scoped>
  .is-ancestor {
    margin: 50px 0;
  } 
</style>

<script>
  export default {
    data () {
      return {
        userName: '',
        email: '',
        password: '',
        confirmPassword: ''
      }
    },
    computed: {
      comparePasswords () {
        return this.confirmPassword != '' && this.password !== this.confirmPassword ? 'Passwords do not match' : ''
      },
      user () {
        return this.$store.getters.user
      },      
      errorMessage () {
        return _.get(this.$store, 'getters.error.message', null)
      },
      loading () {
        return this.$store.getters.loading
      }
    },
    watch: {
      user (value) {
        if (value !== null && value !== undefined) {
          this.$router.push('/profile')
        }
      }
    },
    methods: {
      onCloseErrorMessage () {
        return this.$store.dispatch('setError', {message: null})
      },
      onSignup () {
        this.$store.dispatch('signUserUp', {email: this.email, password: this.password, userName: this.userName})
      },
      onSigninGoogle () {
        this.$store.dispatch('signUserInGoogle')
      },
      onSigninFacebook () {
        this.$store.dispatch('signUserInFacebook')
      },
      onSigninTwitter () {
        this.$store.dispatch('signUserInTwitter')
      },
      onDismissed () {
        this.$store.dispatch('clearError')
      }
    }
  }
</script>
